/* ident "@(#)tftp.h 1.50, dirk" */

/*
 * TFTP.H - TFTP protocol definitions
 *
 * COPYRIGHT (c) 1992,93 Dirk Koeppen EDV-Beratungs-GmbH, W-63073 Offenbach
 *
 * delta date      modification					done by
 * ----- --------- -------------------------------------------- -------------
 *  1.00 1992      initial version				dirk
 */

//#include "regkeys.h"

/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)tftp.h	5.1 (Berkeley) 5/30/85
 */

/* Trivial File Transfer Protocol (IEN-133) */
#define	HDRSIZE		4		/* header size */
/* #define	SEGSIZE		512	*/	/* data segment size */
/* #define	MSEGSIZE	1408 */ 		/* maximum data segment size */
#define	SEGSIZE		512		/* data segment size */
#define	MSEGSIZE	1456 		/* maximum data segment size */
#define MAX_DATA_SIZE 2560		/* 5*512 and less than 1456*2 */
#define	DEFAULT_SEG_SIZE	512		/* data segment size */
#define	MCAST_SEG_SIZE		1456		/* data segment size */

/* packet types  */
#define	P_RRQ	01			/* read request */
#define	P_WRQ	02			/* write request */
#define	P_DATA	03			/* data packet */
#define	P_ACK	04			/* acknowledgement */
#define	P_ERROR	05			/* error code */
#define	P_OACK	06			/* option acknowledgement */

struct	tftphdr {
	short	th_opcode;		/* packet type */
	union {
		short	tu_block;	/* block # */
		short	tu_code;	/* error code */
		char	tu_stuff[1];	/* request packet stuff */
	} th_u;
	char	th_data[1];		/* data or error string */
};

#define	th_block	th_u.tu_block
#define	th_code		th_u.tu_code
#define	th_stuff	th_u.tu_stuff
#define	th_msg		th_data

/* error codes */
#define	EUNDEF		0		/* not defined */
#define	ENOTFOUND	1		/* file not found */
#define	EACCESS		2		/* access violation */
#define	ENOSPACE	3		/* disk full or allocation exceeded */
#define	EBADOP		4		/* illegal TFTP operation */
#define	EBADID		5		/* unknown transfer ID */
#define	EEXISTS		6		/* file already exists */
#define	ENOUSER		7		/* no such user */
#define	EMCASTADDR	8		/* multicast address is not there for this file */

#define	MODE_NETASCII	"netascii"		// I18N
#define	MODE_OCTET	"octet"		// I18N
#define HIGH_PERFORMANCE "MTFTP_HIGH_PERFORMANCE"		// I18N

#ifdef NTSVC
#include "regkeys.h" // global file whic holds all the registry information
#define KEY_LCM_SYSTEM  "SOFTWARE\\Intel\\PXE" 	// I18N
#define KEY_MTFTPD		KEY_LCM_SYSTEM "\\MTFTPD" 	//_TEXT("SOFTWARE\\INTEL\\PXE\\MTFTPD")		// I18N
#define MTFTP_BASE_DIR_VALUE	"BASE_DIR"			// localization ok
#endif
